<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="项目代码" prop="itemno">
        <el-input v-model="queryParams.itemno" placeholder="请输入项目代码" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="项目名称" prop="itemname">
        <el-input v-model="queryParams.itemname" placeholder="请输入项目名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker v-model="queryParams.createTime" style="width: 240px" value-format="yyyy-MM-dd HH:mm:ss" type="daterange"
                        range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" :default-time="['00:00:00', '23:59:59']" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['system:childitem:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['system:childitem:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="ID" align="center" prop="id" />
      <el-table-column label="标识" align="center" prop="itemflag" >
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.ITEM_TYPE" :value="scope.row.itemflag"/>
        </template>
      </el-table-column>
      <el-table-column label="项目代码" align="center" prop="itemno" />
      <el-table-column label="项目名称" align="center" prop="itemname" />
      <el-table-column label="单价 单位分" align="center" prop="itemprice" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <!-- <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['system:childitem:update']">修改</el-button> -->
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['system:childitem:delete']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="openCreate" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <!-- <el-form-item label="项目代码" prop="itemno">
          <el-input v-model="form.itemno" placeholder="请输入项目代码" />
        </el-form-item> -->
        <el-form-item  label="项目代码" prop="itemno">
          <!-- <el-input v-model="form.itemno" placeholder="请输入项目代码" /> -->
          <el-select v-model="selectedValue" filterable remote placeholder="请选择" :remote-method="getDatas" :loading="optionloading" @change="setDatas">
            <el-option
              v-for="item in options"
              :key="item.itemno"
              :label="item.label"
              :value="item.itemno">
            </el-option>
          </el-select>
        </el-form-item>

        <el-form-item  label="项目标识" prop="itemflag">
          <el-input readonly v-model="itemflagShow" placeholder="请输入项目标识" />

          <!-- <el-radio-group v-model="form.itemflag">
            <el-radio v-for="dict in this.getDictDatas(DICT_TYPE.ITEM_TYPE)"
                      :key="dict.value" :label="parseInt(dict.value)">{{dict.label}}</el-radio>
          </el-radio-group>           -->
        </el-form-item>

        <el-form-item label="项目名称" prop="itemname">
          <el-input v-model="form.itemname" placeholder="请输入项目名称" />
        </el-form-item>
        <el-form-item label="单价" prop="itemprice">
          <el-input v-model="form.itemprice" placeholder="请输入单价 单位分" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 对话框( 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="130px">
        <el-form-item   label="项目标识" prop="itemflag">
          <el-radio-group v-model="form.itemflag">
            <el-radio v-for="dict in this.getDictDatas(DICT_TYPE.ITEM_TYPE)"
                      :key="dict.value" :label="parseInt(dict.value)">{{dict.label}}</el-radio>
          </el-radio-group>          
        </el-form-item>
        <el-form-item  label="项目代码" prop="itemno">
          <el-input v-model="form.itemno" placeholder="请输入项目代码" />
        </el-form-item>
        <el-form-item  label="项目名称" prop="itemname">
          <el-input v-model="form.itemname" placeholder="请输入项目名称" />
        </el-form-item>
        <el-form-item  label="单价 单位分" prop="itemprice">
          <el-input v-model="form.itemprice" placeholder="请输入单价 单位分" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>    
  </div>
</template>

<script>
import { createChilditem, updateChilditem, deleteChilditem, getChilditem, getChilditemPage, exportChilditemExcel } from "@/api/system/childitem";
import {DICT_TYPE, getDictDatas} from "@/utils/dict";
import { getXytjjgAll } from "@/api/system/xytjjg";

export default {
  name: "Childitem",
  components: {
  },
  data() {
    return {
      itemflagShow: '',
      optionloading:false,
      selectedValue: '',
      options: [], // 筛选出来的选项
      queryOptions: {
        value: '',
      },      

      ipackageno: null,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 检查项目子列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 是否显示弹出层
      openCreate: false,
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        packageno: null,
        itemflag: null,
        itemno: null,
        itemname: null,
        itemprice: null,
        createTime: [],
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        packageno: [{ required: true, message: "套餐代码 目前只有一个基础包不能为空", trigger: "blur" }],
        itemflag: [{ required: true, message: "标识（1小项目 2临床 ）不能为空", trigger: "blur" }],
        itemno: [{ required: true, message: "项目代码不能为空", trigger: "blur" }],
      },
      // 数据字典
      itemDictDatas: getDictDatas(DICT_TYPE.ITEM_TYPE),      
      packageDictDatas: getDictDatas(DICT_TYPE.PACKAGE_TYPE)

    };
  },
  created() {
    this.ipackageno = this.$route.params.packageno;    
    this.getList();
  },
  methods: {
    getDatas(key) {
      this.optionloading = true;
      
      this.value = key;
      this.queryOptions.value = key;
      getXytjjgAll(this.queryOptions).then(response => {
        this.options = response.data;
        this.optionloading = false;
      });

    },
    setDatas(value){
      console.log(value, "value");
      console.log(this.selectedValue, "selectedValue");      
      //this.selectedValue = "";

      // 通过value找到对应的label，并更新selectedValue
      const selectedOption = this.options.find(option => option.itemno === value);
      if (selectedOption) {
        this.selectedValue = String(selectedOption.itemno) + " ";
        console.log(this.selectedValue, "selectedValue1");              
        this.form.itemno = selectedOption.itemno;
        this.form.itemname = selectedOption.itemname;
        this.form.itemprice = selectedOption.itemprice;
        

        console.log(selectedOption.itemno, "1");
        console.log(selectedOption.itemname, "1");
        console.log(selectedOption.itemprice, "1");
        console.log(selectedOption.itemflag, "1");

        if(selectedOption.itemflag == "0"){
          this.form.itemflag = 1;
          this.itemflagShow = "小项目";
        }else{
          this.form.itemflag  = 2;
          this.itemflagShow = "临床";
        }
      }      
    },

    /** 查询列表 */
    getList() {
      this.loading = true;
      this.queryParams.packageno = this.ipackageno;
      // 执行查询
      getChilditemPage(this.queryParams).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.openCreate = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        packageno: undefined,
        itemflag: undefined,
        itemno: undefined,
        itemname: undefined,
        itemprice: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.openCreate = true;
      this.title = "添加检查子项目";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getChilditem(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改检查子项目";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.form.packageno = this.ipackageno;
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateChilditem(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createChilditem(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.openCreate = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除检查子项目编号为"' + id + '"的数据项?').then(function() {
          return deleteChilditem(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.$modal.confirm('是否确认导出所有检查项目子数据项?').then(() => {
          this.exportLoading = true;
          return exportChilditemExcel(params);
        }).then(response => {
          this.$download.excel(response, '检查项目子.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
